// LightWave Modeler Script
// Ver. 0.69
// DXF_Comes.ls: Load DXF with Colors.
// Note: I Am Not Responsible for Any Damage on Your Intellectual Data!!
// Author:   ATSURO SETO ArturoSeth@gmail.com
// URL:       http://www.cc.rim.or.jp/~atsuro/

@warnings
@version 2.6
@script modeler
@name Dxf_Comes
@strict
//@unused
main
{
	var gLastDir=nil;
	var dxffile=nil;
	var dxfPath=nil;
	var splitted=nil;
	var curObj=nil;
	var curSurf=nil;
	var eachColHasLay[256];
	eachColHasLay[256]=nil;
	var lineCount=0;
	var totalFaces=0;
	var s="";
	var layStr="";
	var lname="";
	var idStr="";
	var idx="";
	var xcoords[4], ycoords[4], zcoords[4];
	xcoords[4]=0.0;
	ycoords[4]=0.0;
	zcoords[4]=0.0;
	var i=0;
	var m=1; 
	var p[3];
	p[3]=<0,0,0>;
	var num_polygons=0;
	var vec=<0,0,0>;
	var result;
	
	//debug();
//Find a free layer.
var emptyLyr = lyrempty();

//Switch to that layer.
lyrsetfg(emptyLyr[1]);

//	new();
	curObj = Mesh(0);
	gLastDir=globalrecall("DxfComesDir",getdir("Objects"));
	if((dxfPath = getfile("DxfComesDir","*.dxf",gLastDir,1))==nil) return;
	splitted=split(dxfPath);
	gLastDir=splitted[1]+splitted[2];
	if ((dxffile=File(dxfPath, "r"))==nil)return;//info(dxfPath);
/////////////////////////////////////////////////////////////////////////////////////////
	selmode(USER);
	moninit(dxffile.linecount(), "Doing...");
	editbegin();
	while (!dxffile.eof())           
	{
		s=trim(dxffile.read()); // get a line from dxffile to strbuf
		lineCount++;monstep();
		if (s=="EOF") 	break;
		if (s!="3DFACE")	continue;
		totalFaces++;//3DFACE inside

		s=trim(dxffile.read()); // ignore number 
		lineCount++;monstep();
		if (s.asInt()!=8)
			info(lineCount.asStr() + "> Warning! Expected code 8 but " + s.asInt());

		layStr=trim(dxffile.read()); // layer name.
		lineCount++;monstep();

		s=trim(dxffile.read()); // Color code
		lineCount++;monstep();
		if (s.asInt() != 62 && s.asInt()!=70) // Color code 62
		{
			info(lineCount.asStr() + ">DXF Color Code should be 62 but "+ s.asInt());
			dxffile.close();
			return;
		}

		idStr=trim(dxffile.read()); // Color index
		lineCount++;monstep();
		for(i=1; i<=eachColHasLay.count(); i++)
		{	
			(lname, idx) = parse(", ", eachColHasLay[i]);
			if(idx==idStr && lname==layStr)
				break; //eachColHasLay[i] is the same as on the lineCount
		}// if not break, then i==eachColHasLay.count()+1;
		eachColHasLay[i]=string(layStr+", "+idStr);
		for(i=1; i<=4; i++)//lower 1 digit increasing 0to3 for 4vertices
		{
			s=trim(dxffile.read());//granted id x10 | quad0123 = 10,11,12,13
			s=trim(dxffile.read()); //Coordinates x value
			xcoords[i]=s.asNum();///////////////////////////////////

			s=trim(dxffile.read());//granted id y20 | quad0123 = 20,21,22,23
			s=trim(dxffile.read()); //Coordinates  y value
			ycoords[i]=s.asNum();
			
			s=trim(dxffile.read());//granted id z30 | quad0123 = 30,31,32,33
			s=trim(dxffile.read()); //Coordinates z value
			zcoords[i]=s.asNum();
			
			lineCount++;        	monstep();
			lineCount++;        	monstep();
			lineCount++;        	monstep();
			lineCount++;        	monstep();
			lineCount++;        	monstep();
			lineCount++;        	monstep();
		}

		p[1]=addpoint(<xcoords[3], zcoords[3], ycoords[3]>);
		p[2]=addpoint(<xcoords[2], zcoords[2], ycoords[2]>);
		p[3]=addpoint(<xcoords[1], zcoords[1], ycoords[1]>);
		result=addpolygon(p, layStr);
		if(result)num_polygons++;
		if(xcoords[3]!=xcoords[4]||ycoords[3]!=ycoords[4]||zcoords[3]!=zcoords[4])
		{
			p[1]=addpoint(<xcoords[1], zcoords[1], ycoords[1]>);
			p[2]=addpoint(<xcoords[4], zcoords[4], ycoords[4]>);
			p[3]=addpoint(<xcoords[3], zcoords[3], ycoords[3]>);
			result=addpolygon(p, layStr);
			if(result)num_polygons++;
		}
	}
	if(dxffile.linecount()!=lineCount) warn("Wrong lineCount!<br>", dxffile.linecount(), " != ", lineCount);	
	editend();
	monend();
	dxffile.close();
	eachColHasLay.sortA();
	moninit(eachColHasLay.count());
	for(i=1;i<=eachColHasLay.count(); i++)
	{
		(lname,idx)=parse(", ", eachColHasLay[i]);
		vec=idx2col(idx.asInt());
		curSurf=Surface(curObj,lname);
		curSurf.setValue(SURFCOLR,<255*vec.x,255*vec.y, 255*vec.z>);
		selpolygon(SET,SURFACE,lname);
		mergepoints();
		selpolygon(CLEAR);
		monstep();
	}
	monend();
	info("loaded "+splitted[3]+splitted[4]+"<br>"+num_polygons+" polygons.");
    	globalstore("DxfComesDir",gLastDir);
	return;
}

idx2col: i 
{
	var maxi;
	var inc=0.0;
	var curCol=<0.0, 0.0, 0.0>;
	var up2digts=0;

	if(i<10)
	{
		switch(i){
			case 1:				//1|0|0=4;
				curCol.x=1; curCol.y=0; curCol.z=0; //i=1;//Red
				break;
			case 2:				//1|1|0=6;
				curCol.x=1; curCol.y=1; curCol.z=0;//i=2;//Yellow
				break;
			case 3:				//0|1|0=2;
				curCol.x=0; curCol.y=1; curCol.z=0;//i=3;//Green
				break;
			case 4:				//0|1|1=3;
				curCol.x=0; curCol.y=1; curCol.z=1; //i=4;//Cyan
				break;
			case 5:				//0|0|1=1;
				curCol.x=0; curCol.y=0; curCol.z=1; //i=5;//Blue
				break;
			case 6:				//1|0|1=5;
				curCol.x=1; curCol.y=0; curCol.z=1; //i=6;//Magenta
				break;
			case 7:				//1|1|1=7;
				curCol.x=1; curCol.y=1; curCol.z=1; //i=7;//White
				break;
			default:			//case 0:Be defined by Layer
				curCol.x=0; curCol.y=0; curCol.z=0; //i=8;i=9;//Undefined Black
				break;
		}
	}//i<10 END	
	
	else if(i<250)
	{
		up2digts =(i/10).asInt(); // Extract upper 2 digits of 10 TO 249
		inc=.25;
		switch(up2digts)
		{
			case 1:	case 2:	case 3:	case 4://10red TO 40orange
				curCol.x=1; curCol.y=(up2digts - 1)*inc; curCol.z=0;
				break;
			case 5:	case 6:	case 7:	case 8:			//50yellow TO 80yellow green
				curCol.x=1 - (up2digts - 5)*inc; curCol.y=1; curCol.z=0;
				break;
			//90{0,1,0}green//100{0,1,.25}green turqoise//110{0,1,.5}turqouise//120{0,1,.75}blueTurqoise
			case 9:	case 10: case 11: case 12:
				curCol.x=0; curCol.y=1; curCol.z=(up2digts - 9)*inc;
				break;
			case 13: case 14: case 15: case 16://{0,1,1};130cyan//{0,.75,1};140//{0,.5,1};150//{0,.25,1};160	
				curCol.x=0; 
				curCol.y=1 - (up2digts - 13)*inc; 
				curCol.z=1;
				break;
			//{0,0,1};170blue//{.25,0,1};180blue violet//{.5,0,1};190violet//{.75,0,1};200violet magenta
			case 17: 
			case 18: 
			case 19: 
			case 20:
				curCol.x=(up2digts - 17)*inc; curCol.y=0; curCol.z=1;
				break;
			//{1,0,1};210magenta;//{1,0,.75}; 220 reddish magenta//{1,0,.5}; 230 cinnabar//{1,0,.25}; 240 reddish cinnabar
			case 21: case 22: case 23: case 24:
				curCol.x=1; curCol.y=0; curCol.z=1 - (up2digts - 21)*inc; 
				break;
			default:
				break;
		}//switch((int)i/10) END

		switch(i%10)
		{
			case 2:	case 3:			//12 TO 242;//13 TO 243;
				curCol.x*=.65; curCol.y*=.65; curCol.z*=.65;
				break;
			case 4:	case 5:			//14 TO 244;//15 TO 245;
				curCol.x*=.5; curCol.y*=.5; curCol.z*=.5;
				break;
			case 6:	case 7:			//16 TO 246;//17 TO 247;
				curCol.x*=.3; curCol.y*=.3; curCol.z*=.3;
				break;
			case 8: case 9:			//18 TO 248;//19 TO 249;
				curCol.x*=.15; curCol.y*=.15; curCol.z*=.15;
				break;
			default:			//case 0://10 TO 240;//case 1://11 TO 241;
				break;
		}//switch (i%10) END

		//get maxiimum value among the R,G,B which got decayed 
		//by (*.65, *.5, *.3, *.15) in the last switch
		maxi=max(max(curCol.x, curCol.y),curCol.z);
		
		switch(i%10)
		{
			//11 TO 241;//13 TO 243;//15 TO 245;//17 TO 247;//19 TO 249; // Care odd cases
			case 1:	case 3:	case 5:	case 7:	case 9:
				curCol.x=curCol.x/2+maxi/2; curCol.y=curCol.y/2+maxi/2; curCol.z=curCol.z/2+maxi/2;
				break;
			default:
			//case 0://10 TO 240;//case 2://12 TO 242;//case 4://14 TO 244;//case 6://16 TO 246;//case 8://18 TO 248;
				break;
		}//switch (i%10) END
	}//i<250 END
	else if(i>=250)
	{
		curCol.x=.33; curCol.y=.33; curCol.z=.33;
		inc=.134;
		curCol.x=curCol.x+(i - 250)*inc; 
		curCol.y=curCol.y+(i - 250)*inc; 
		curCol.z=curCol.z+(i - 250)*inc;
	}
	//info("dxfColor%d: rgb<%.4f, %.4f, %.4f>\n", i, curCol.x, curCol.y, curCol.z);
	return (curCol);
}
trim: strTmp
{
	var strBits="";
	strTmp.pack();//left Spaces Removed 2 3             //mid and MostRightRemains
	strBits=parse(" ",strTmp);//@left, Spaces, Removed, 2, 3@//Arrayed
	//strBits.trunc();
	if(strBits[1]==nil) error("StrBits[1]==nil");
	//info("trimmed [", strBits[1], "]");
	return strBits[1];
}
