// LightWave Modeler Script
// Ver. 0.69
// Convert LightWave's Diffuse RGB vector to DXF's Index Color 0 To 255 and Export DXF.
// Note: I Am Not Responsible for Any Damage on Your Intellectual Data!!
// Author:   ATSURO SETO ArturoSeth@gmail.com
// URL:       http://www.cc.rim.or.jp/~atsuro/

@warnings
@version 2.6
@script modeler
@name Dxf_Goes

gLastDir=nil;
name2index=@"",""@;

main
{
 	//debug();
	var trinum=0;
	curObj = Mesh(0);
	curName = curObj.name;
	gLastDir=globalrecall("DxfGoesDir",getdir("Objects"));
	//info(gLastDir);
	
	if((dxfPath = getfile("DxfGoesDir",curName+".dxf",gLastDir,0))==nil) return;
	splitted=split(dxfPath);
	gLastDir=splitted[1]+splitted[2];
	if ((dxffile=File(dxfPath, "w"))==nil)return;//info(dxfPath);
	
	
    selmode(USER);
    var total;
    (total) = polycount();
    if(!total)
    {
        error("<br>You must have geometry to perform this operation");
	    dxffile.close();
        return;
    }
    editbegin();
    writeHEADER(dxffile, splitted[3]+splitted[4]);
    writeTABLES(dxffile);
	dxffile.writeln("0\nSECTION\n2\nENTITIES");
moninit(total, "Doing...");
	for(i=1; i<total+1; i++)
	{
	    ppc = polypointcount(polygons[i]);
	    if(ppc>4|| ppc<3)// continue;
	    {
	        warn(string(ppc)+ "th Verts Poly found and ignored!<br>Only Quads and Triangles will be converted.");
	        monstep();
	        continue;
	    }
	   
	    pnts = polyinfo(polygons[i]);//LightWave pnts[2],[3],[4] Clock Wise Tri
	    dxffile.writeln("0\n3DFACE\n8");//8 then Layer Name comes next.
	    dxffile.writeln(string(pnts[1]));//LAYERNAME
	    dxffile.writeln("62");//62 dxf color code
		for(j=0; j<sizeof(name2index); j++)
		{
			if(name2index[j+1][1]==string(pnts[1])){
				strIndex=name2index[j+1][2];
				break;
			}
		}
	    dxffile.writeln(strIndex);
	    p0=pointinfo(pnts[4]);//DXF Counter Clock Wise
	    dxffile.writeln("10\n"+string(p0.x));
	    dxffile.writeln("20\n"+string(p0.z));
	    dxffile.writeln("30\n"+string(p0.y));
	    p1=pointinfo(pnts[3]);
	    dxffile.writeln("11\n"+string(p1.x));
	    dxffile.writeln("21\n"+string(p1.z));
	    dxffile.writeln("31\n"+string(p1.y));
	    p2=pointinfo(pnts[2]);
	    dxffile.writeln("12\n"+string(p2.x));
	    dxffile.writeln("22\n"+string(p2.z));
	    dxffile.writeln("32\n"+string(p2.y));
	   // debug();
	    p3=(ppc==3)? p2: pointinfo(pnts[5]);//DXF's 2nd Tri p2>p3>p0
	    dxffile.writeln("13\n"+string(p3.x));
	    dxffile.writeln("23\n"+string(p3.z));
	    dxffile.writeln("33\n"+string(p3.y));
	    trinum+=(ppc==3)? 1: 2;
	    monstep();
	}
	dxffile.writeln("0\nENDSEC\n0\nEOF");
	monend();
	editend();
	dxffile.close();
    info("Saved "+splitted[3]+splitted[4]+"<br>"+trinum+" triangles.");
    	globalstore("DxfGoesDir",gLastDir);
}
writeHEADER: dxffile, strFname
{
	dxffile.writeln("0\nSECTION\n2\nHEADER");
	dxffile.writeln("999\nUsing DXF_Goes.ls (c) Atsuro Seto");
	dxffile.writeln("0\nENDSEC");

	return;
}
writeTABLES: dxffile
{
	curObj=Mesh(0);
	curObjSurfsList=Surface(curObj);
	totalLayers=curObjSurfsList.size();
	//info("totalLayers "+string(totalLayers));
	dxffile.writeln("0\nSECTION\n2\nTABLES");
	dxffile.writeln("0\nTABLE\n2\nLAYER\n70");
	dxffile.writeln(string(totalLayers));
	for(i=1;i<=totalLayers;i++)
	{
		//        myfullname=curObjSurfsList[i];
		curSurf=Surface(curObj,curObjSurfsList[i]);
		// colour
		RxGyBz=curSurf.getValue(SURFCOLR);
		dxffile.writeln("0\nLAYER\n2");
		dxffile.writeln(string(curObjSurfsList[i]));
		dxffile.writeln("70\n64\n62");
		dxf_index=mostResemble(RxGyBz);
		
		var strName=string(curSurf.name);
		
		name2index[i]=@strName, dxf_index.asStr()@;
		//info("name1To256[" + string(dxf_index+1)+"] "+ name1To256[dxf_index+1]);

		//var dxfRGB=idx2col(dxf_index);dxffile.writeln(string(i) + "] "+ strName+ " <" + RxGyBz.x.asStr() + ", " + RxGyBz.y.asStr() + ", " + RxGyBz.z.asStr() + "><br>"+  string(dxf_index) +"] DXF index color <" + dxfRGB.x.asStr() + ", " + dxfRGB.y.asStr() + ", " + dxfRGB.z.asStr() +">");
		
		dxffile.writeln(string(dxf_index));
		dxffile.writeln("6\nCONTINUOUS");
	}
	dxffile.writeln("0\nENDTAB\n0\nENDSEC");
	return totalLayers;
}
mostResemble: color
{
	cur = <1.0,1.0,1.0>;
	mini_me =Magnitude(cur);
	index=0;
	for (i = 0; i <= 255; i++)
	 {
		cur = idx2col(i);
		diff =  Magnitude(<cur.x - color.x, cur.y - color.y, cur.z - color.z>);
		if (diff < mini_me)
		{
			mini_me = diff;
			index = i;
		}
	}
	mini_me =Magnitude(<color.x, color.y , color.z>);

	return index;
}
Magnitude:vec
{
	return sqrt(vec.x*vec.x + vec.y*vec.y + vec.z*vec.z);
}

idx2col: i 
{
	var maxi;
	var inc=0.0;
	var curCol=<0.0, 0.0, 0.0>;
	var up2digts=0;

	if(i<10)
	{
		switch(i){
			case 1:				//1|0|0=4;
				curCol.x=1; curCol.y=0; curCol.z=0; //i=1;//Red
				break;
			case 2:				//1|1|0=6;
				curCol.x=1; curCol.y=1; curCol.z=0;//i=2;//Yellow
				break;
			case 3:				//0|1|0=2;
				curCol.x=0; curCol.y=1; curCol.z=0;//i=3;//Green
				break;
			case 4:				//0|1|1=3;
				curCol.x=0; curCol.y=1; curCol.z=1; //i=4;//Cyan
				break;
			case 5:				//0|0|1=1;
				curCol.x=0; curCol.y=0; curCol.z=1; //i=5;//Blue
				break;
			case 6:				//1|0|1=5;
				curCol.x=1; curCol.y=0; curCol.z=1; //i=6;//Magenta
				break;
			case 7:				//1|1|1=7;
				curCol.x=1; curCol.y=1; curCol.z=1; //i=7;//White
				break;
			default:			//case 0:Be defined by Layer
				curCol.x=0; curCol.y=0; curCol.z=0; //i=8;i=9;//Undefined Black
				break;
		}
	}//i<10 END	
	
	else if(i<250)
	{
		up2digts =(i/10).asInt(); // Extract upper 2 digits of 10 TO 249
		inc=.25;
		switch(up2digts)
		{
			case 1:	case 2:	case 3:	case 4://10red TO 40orange
				curCol.x=1; curCol.y=(up2digts - 1)*inc; curCol.z=0;
				break;
			case 5:	case 6:	case 7:	case 8:			//50yellow TO 80yellow green
				curCol.x=1 - (up2digts - 5)*inc; curCol.y=1; curCol.z=0;
				break;
			//90{0,1,0}green//100{0,1,.25}green turqoise//110{0,1,.5}turqouise//120{0,1,.75}blueTurqoise
			case 9:	case 10: case 11: case 12:
				curCol.x=0; curCol.y=1; curCol.z=(up2digts - 9)*inc;
				break;
			case 13: case 14: case 15: case 16://{0,1,1};130cyan//{0,.75,1};140//{0,.5,1};150//{0,.25,1};160	
				curCol.x=0; 
				curCol.y=1 - (up2digts - 13)*inc; 
				curCol.z=1;
				break;
			//{0,0,1};170blue//{.25,0,1};180blue violet//{.5,0,1};190violet//{.75,0,1};200violet magenta
			case 17: 
			case 18: 
			case 19: 
			case 20:
				curCol.x=(up2digts - 17)*inc; curCol.y=0; curCol.z=1;
				break;
			//{1,0,1};210magenta;//{1,0,.75}; 220 reddish magenta//{1,0,.5}; 230 cinnabar//{1,0,.25}; 240 reddish cinnabar
			case 21: case 22: case 23: case 24:
				curCol.x=1; curCol.y=0; curCol.z=1 - (up2digts - 21)*inc; 
				break;
			default:
				break;
		}//switch((int)i/10) END

		switch(i%10)
		{
			case 2:	case 3:			//12 TO 242;//13 TO 243;
				curCol.x*=.65; curCol.y*=.65; curCol.z*=.65;
				break;
			case 4:	case 5:			//14 TO 244;//15 TO 245;
				curCol.x*=.5; curCol.y*=.5; curCol.z*=.5;
				break;
			case 6:	case 7:			//16 TO 246;//17 TO 247;
				curCol.x*=.3; curCol.y*=.3; curCol.z*=.3;
				break;
			case 8: case 9:			//18 TO 248;//19 TO 249;
				curCol.x*=.15; curCol.y*=.15; curCol.z*=.15;
				break;
			default:			//case 0://10 TO 240;//case 1://11 TO 241;
				break;
		}//switch (i%10) END

		//get maxiimum value among the R,G,B which got decayed 
		//by (*.65, *.5, *.3, *.15) in the last switch
		maxi=max(max(curCol.x, curCol.y),curCol.z);
		
		switch(i%10)
		{
			//11 TO 241;//13 TO 243;//15 TO 245;//17 TO 247;//19 TO 249; // Care odd cases
			case 1:	case 3:	case 5:	case 7:	case 9:
				curCol.x=curCol.x/2+maxi/2; curCol.y=curCol.y/2+maxi/2; curCol.z=curCol.z/2+maxi/2;
				break;
			default:
			//case 0://10 TO 240;//case 2://12 TO 242;//case 4://14 TO 244;//case 6://16 TO 246;//case 8://18 TO 248;
				break;
		}//switch (i%10) END
	}//i<250 END
	else if(i>=250)
	{
		curCol.x=.33; curCol.y=.33; curCol.z=.33;
		inc=.134;
		curCol.x=curCol.x+(i - 250)*inc; 
		curCol.y=curCol.y+(i - 250)*inc; 
		curCol.z=curCol.z+(i - 250)*inc;
	}
	//printf("dxfColor%d: rgb<%.4f, %.4f, %.4f>\n", i, curCol.x, curCol.y, curCol.z);
	return (curCol);
}
